package com.bocloud.ams.entity.collection;

import com.bocloud.ams.annotation.ColumnType;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * @author huliwei
 * @date 2023/4/25
 */
@Data
@Table("ci_collection_history_bak")
public class CollectionHistoryBak  extends Generic {

    @PK(value = PKStrategy.SELF)
    private Long id;
    @Column(value = "module_id")
    private Long moduleId;
    @Column(value = "instance_id")
    private Long instanceId;
    @Column(value = "instance_uuid",length = 256)
    private String instanceUuid;
    @Column(value = "task_instance_id", nullable = false)
    private Long taskInstanceId;
    @Column(value = "type", length = 64, nullable = false)
    private String type;//取值范围:ADD、EDIT
    @Column(value = "status", length = 64)
    private String status;//取值范围：SUCCESS、FAILED、RECONCILED未调和
    @ColumnType(value = "longtext")
    @Column(value = "output")
    private String output;//原始输出
    @Column(value = "operator", length = 128, nullable = false)
    private String operator;
    @Column(value = "gmt_create", length = 64, nullable = false)
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;
    @Column(value = "reason",length = 2048)
    private String reason;//原因
    @IgnoreAll
    private List<CollectionHistoryItem> historyItems;
}
