package com.bocloud.ams.entity.instance;


import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * @ClassName: CmdbInstanceAuthority
 * @Description
 * @Author yangzhenrong
 * @Date 2022/5/23 18:10
 * @Version 1.0
 **/
@Data
@Table("ci_instance_authority")
@EqualsAndHashCode(callSuper = true)
public class InstanceAuthority extends GenericEntity {
    @PK
    private Long id;
    @Column(value = "module_id", nullable = false)
    private Long moduleId;
    @Column(value = "instance_id", nullable = false)
    private Long instanceId;
    @Column(value = "role_id", nullable = false)
    private Long roleId;
    @Column(value = "user_id")
    private Long userId;
    @Column(value = "auths", length = 512, nullable = false)
    private String auths;
    @IgnoreAll
    private Boolean isOverwrite;
    @IgnoreAll
    private List<Long> instanceIds;
    @IgnoreAll
    private String roleName;
    @IgnoreAll
    private String authNames;
    @IgnoreAll
    private String userName;
    @IgnoreAll
    private String userIds;

    public InstanceAuthority() {

    }

    public InstanceAuthority(Long moduleId, Long instanceId, Long roleId, Long userId, String auths) {
        this.moduleId = moduleId;
        this.instanceId = instanceId;
        this.roleId = roleId;
        this.userId = userId;
        this.auths = auths;
    }
}
