package com.bocloud.ams.entity.instance;



import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @ClassName: CmdbInstanceRelationHistoryRecord
 * @Description 历史关系变更历史记录
 * @Author majiali
 * @Date 2022/6/8 15:49
 * @Version 1.0
 **/
@Data
@Table("ci_instance_relation_history_record")
@EqualsAndHashCode(callSuper = true)
public class InstanceRelationHistoryRecord extends GenericEntity {
    @PK
    private Long id;
    @Column("module_id")
    private Long moduleId;
    @Column("instance_id")
    private Long instanceId;
    /**
     * 操作类型： 取消关联 cancel 关联 relation
     */
    @Column("type")
    private String type;
    /**
     * 关联方式： 手动-MANUAL  自动-AUTO
     */
    @Column("way")
    private String way;
    /**
     * 当前资源是否是源模型实例 1：是 0：否
     */
    @Column("is_source")
    private Boolean isSource;
    @Column("module_relation_id")
    private Long moduleRelationId;
    @Column("relation_category_id")
    private Long relationCategoryId;
    @Column("auto_relation_rule_id")
    private Long autoRelationRuleId;
    @Column("alter_before")
    private String alterBefore;
    @Column("alter_after")
    private String alterAfter;
    @Column("reason")
    private String reason;
    @Column("relation_instance_id")
    private Long relationInstanceId;

    @Column("exec_time")
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date execTime;
    @Column("exec_id")
    private Long execId;
    @IgnoreAll
    private String executor;
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String moduleRelationName;
    @IgnoreAll
    private String relationCategoryName;
    @IgnoreAll
    private String moduleCode;
    @IgnoreAll
    private String moduleName;
}
