package com.bocloud.ams.entity.module;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

@Table("ci_property_item")
@Data
@EqualsAndHashCode(callSuper = true)
public class PropertyItem extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 类型
     */
    @Column("value")
    private String value;

    /**
     * 结构项ID
     */
    @Column("code")
    private String code;

    /**
     * 所属属性id
     */
    @Column("property_id")
    private Long propertyId;
    /**
     * 所属模型id
     */
    @Column("module_id")
    private Long moduleId;

    /**
     * TEXTFIELD:单行文本
     * TEXTAREA:多行文本
     * SELECTREDIO:下拉单选
     * SELECTCHECKBOX:下拉多选
     * DATE:日期
     * TIME:时间
     * TEXTENCRYPT:数据加密
     * INTEGER:整数
     * FLOAT:小数
     * JSON:json
     * BOOLEAN:布尔值
     * ci_property_pool_item.type
     */
    @Column("type")
    private String type = "TEXTFIELD";

    /**
     * 表格属性中结构项数据的下拉选项数据
     */
    @Column("item_value")
    private String itemValue;

    /**
     * itemValue 转化成 集合
     */
    @IgnoreAll
    private List<PropertyItem> itemList;
}
