package com.bocloud.ams.entity.module;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author 胡立伟
 * @program: bocloud.ams
 * @description:
 * @date 2022/5/12 17:16
 */
@Table("ci_topology_config")
@Data
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class TopologyConfig extends GenericEntity {

    /**
     * 主键ID
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 拓扑图分组id
     */
    @Column("category_id")
    private Long categoryId;

    @IgnoreAll
    private String categoryName;

    /**
     * 起始模型id
     */
    @Column("start_module_id")
    private Long startModuleId;

    @IgnoreAll
    private String startModuleName;

    /**
     * 拓扑层级 (是不包括起始层级的)
     */
    @Column("topology_level")
    private Integer topologyLevel;

    /**
     * 忽略模型id集合
     */
    @Column("ignore_module_ids")
    private String ignoreModuleIds;

    /**
     * 忽略模型可能是多选
     */
    @IgnoreAll
    private List<Long> ignoreModuleId;

    /**
     * 途径模型id
     */
    @Column("way_module_ids")
    private String wayModuleIds;

    /**
     * 途径模型可能是多选的
     */
    @IgnoreAll
    private List<Long> wayModuleId;

    /**
     * 拓扑路径
     */
    @Column("topology_path")
    private String topologyPath;

    @IgnoreAll
    private String topologyPathName;

    /**
     * 拓扑路径方向：0代表正向；1代表反方向
     */
    @Column("path_direction")
    private Boolean pathDirection;

    /**
     * 配置类型
     */
    @Column("config_type")
    private String configType;

    /**
     * 起始类型
     */
    @Column("start_type")
    private String startType;

    /**
     * 向上层数
     */
    @Column("topology_level_up")
    private Integer topologyLevelUp;

    /**
     * 向下层数
     */
    @Column("topology_level_down")
    private Integer topologyLevelDown;

}
