package com.bocloud.ams.service.internal;


import com.bocloud.cmp.boot.model.BocloudToken;
import com.megatron.common.model.GeneralResult;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;



import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author 胡立伟
 * @program: bocloud.ams
 * @description:
 * @date 2022/6/16 11:02
 */
@Service
public class AmsInternalService implements InitializingBean {
    private Map<String, Object> headers = new HashMap<>(4);
    private static final com.megatron.framework.core.Service SERVICE = com.megatron.framework.core.Service.create("ams");

    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;

    public boolean scheduleInspectBroadcast(Long id, HttpMethod method) {
        boolean success = false;
        String taskUrl = "/v1/collection/tasks/" + id + "/schedule";
        List<RemoteService> services = serviceFactory.buildAll(SERVICE, taskUrl, method, headers, null);
        for (RemoteService service : services) {
            GeneralResult<?> result = service.invoke();
            if (result.isFailed()) {
                continue;
            }
            if ("fixed".equals(result.getData().toString())) {
                success = true;
                break;
            }
        }
        return success;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }
}
