package com.bocloud.ams.service.utils;

import java.util.Arrays;
import java.util.List;


/**
 * @Description: 属性值类型常量
 * @Author: majiali
 * @CreateTime: 2022/5/6 10:12
 */
public class PropertyConstant {

    public static final String DATA_ALL_AUTH_MANAGER_ID_KEY = "data_all_auth_manager_id";

    public static final String GLOBALLY_UNIQUE_IDENTIFIER = "GLOBALLYUNIQUEIDENTIFIER";

    public static final List<String> RESERVED_MODULE_CODES =
            Arrays.asList("id", "uuid", "name", "gmt_create", "gmt_modify", "is_deleted",
                    "module_id", "creator_id", "mender_id", "module_code", DATA_ALL_AUTH_MANAGER_ID_KEY);


    /**
     * @Description: 属性池表格引入类型
     */
    public static final String TABLE_TYPE_ONE = "1";
    /**
     * @Description: 属性池表格自定义
     */
    public static final String TABLE_TYPE_ZERO = "0";


    /**
     * @Description: 属性池/属性 值类型
     */
    public class PropertyType {
        //单行文本
        public static final String TEXTFIELD = "TEXTFIELD";

        //多行文本
        public static final String TEXTAREA = "TEXTAREA";

        //下拉单选
        public static final String SINGLESELECT = "SINGLESELECT";

        //下拉多选
        public static final String MULTISELECT = "MULTISELECT";

        /**
         * 单选
         */
        public static final String RADIO = "RADIO";
        /**
         * 多选
         */
        public static final String CHECKBOX = "CHECKBOX";

        //引用
        public static final String QUOTE = "QUOTE";

        //日期
        public static final String DATE = "DATE";

        //时间
        public static final String TIME = "TIME";

        //数据加密
        public static final String TEXTENCRYPT = "TEXTENCRYPT";

        //整数
        public static final String INTEGER = "INTEGER";

        //小数
        public static final String FLOAT = "FLOAT";

        //单行表格
        public static final String SINGLELINETABLE = "SINGLELINETABLE";

        //多行表格
        public static final String MULTILINETABLE = "MULTILINETABLE";

        //json
        public static final String JSON = "JSON";

        //布尔值
        public static final String BOOLEAN = "BOOLEAN";

    }

    //默认值类型
    public class DefaultValueType {

        //固定值：FIXED
        public static final String FIXED = "FIXED";

        //内置函数：INNERFUN
        public static final String INNERFUN = "INNERFUN";

        //自增ID：AUTOINCRID
        public static final String AUTOINCRID = "AUTOINCRID";

        //流水号：SERIALNUM
        public static final String SERIALNUM = "SERIALNUM";
    }


}
