package com.bocloud.ams.service.utils;

import org.apache.commons.collections.CollectionUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author 胡立伟
 * @program: bocloud.ams
 * @description:
 * @date 2022/5/18 13:49
 */
public class paginationUtil {
    /**
     * 内存分页
     *
     * @param records  待分页的数据
     * @param pageNum  当前页码
     * @param pageSize 每页显示的条数
     * @return 分页之后的数据
     */
    public static <T> Map<String,Object> pagination(List<T> records, int pageNum, int pageSize) {
        Map<String,Object> map=new HashMap<>();
        if (CollectionUtils.isEmpty(records)) {
            return null;
        }
        int totalCount = records.size();
        int remainder = totalCount % pageSize;
        int pageCount = (remainder > 0) ? totalCount / pageSize + 1 : totalCount / pageSize;
        map.put("totalCount",totalCount);
        map.put("pageCount",pageCount);
        map.put("pageNo",pageNum);
        map.put("pageSize",pageSize);
        if (remainder == 0) {
            map.put("list",records.stream().skip((pageNum - 1) * pageSize).limit(pageSize).collect(Collectors.toList()));
            return map;
        } else {
            if (pageNum == pageCount) {
                map.put("list", records.stream().skip((pageNum - 1) * pageSize).limit(totalCount).collect(Collectors.toList()));
                return map;
            } else {
                map.put("list",records.stream().skip((pageNum - 1) * pageSize).limit(pageSize).collect(Collectors.toList()));
                return map;
            }
        }
    }

}
